﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MusicCommunity.Adapters.ClassifiersTableAdapters;
using MusicCommunity.Adapters;
namespace MusicCommunity.Classes
{
    public class ClassifierAdapterSpeaker
    {
        public const string GROUPPERSIMMIONSTYPE = "GroupPermisstionsType";
        public const string MUSICINSTRUMENTS = "MusicInstruments";
        public const string STATES = "States";
        public const string ROCKGENRES = "RockGenres";
        public const string SENDERTYPE = "SenderType";

        public static List<GroupPermissionType> GetGroupPermTypes()
        {
            
            if (HttpContext.Current.Application[GROUPPERSIMMIONSTYPE] == null)
            {
                GroupPermissionTypeTableAdapter adapter = new GroupPermissionTypeTableAdapter();
                var permTable = adapter.GetData();
                List<GroupPermissionType> permList = new List<GroupPermissionType>();
                foreach (var row in permTable)
                {
                    GroupPermissionType type = new GroupPermissionType();
                    type.ID = Convert.ToInt32(row["ID"]);
                    type.PermissionType = row["PermissionType"].ToString();
                    permList.Add(type);
                }
                return permList;
            }
            else
                return HttpContext.Current.Application[GROUPPERSIMMIONSTYPE] as List<GroupPermissionType>;
        }
        public static List<MusicInstruments> GetMusicInstruments()
        {
            if (HttpContext.Current.Application[MUSICINSTRUMENTS] == null)
            {
                MusicInstrumentsTableAdapter adapter = new MusicInstrumentsTableAdapter();
                var instrTable = adapter.GetData();
                List<MusicInstruments> instrList = new List<MusicInstruments>();
                foreach (var row in instrTable)
                {
                    MusicInstruments instr = new MusicInstruments();
                    instr.ID = Convert.ToInt32(row["ID"]);
                    instr.InstrumentName = row["InstrumentName"].ToString();
                    instrList.Add(instr);
                }
                return instrList;
            }
            else
                return HttpContext.Current.Application[MUSICINSTRUMENTS] as List<MusicInstruments>;
        }
        public static List<State> GetStates()
        {
            if (HttpContext.Current.Application[STATES] == null)
            {
                StateTableAdapter adapter = new StateTableAdapter();
                var statesTable = adapter.GetData();
                List<State> statesList = new List<State>();
                foreach (var row in statesTable)
                {
                    State state = new State();
                    state.ID = Convert.ToInt32(row["ID"]);
                    state.State1 = row["State"].ToString();
                    statesList.Add(state);
                }
                return statesList;
            }
            else
                return HttpContext.Current.Application[STATES] as List<State>;
        }
        public static List<RockGenres> GetRockGenres()
        {
            if (HttpContext.Current.Application[ROCKGENRES] == null)
            {
                RockGenresTableAdapter adapter = new RockGenresTableAdapter();
                var genresTable = adapter.GetData();
                List<RockGenres> genresList = new List<RockGenres>();
                foreach (var row in genresTable)
                {
                    RockGenres genre = new RockGenres();
                    genre.ID = Convert.ToInt32(row["ID"]);
                    genre.Genre = row["Genre"].ToString();
                    genresList.Add(genre);
                }
                return genresList;
            }
            else
                return HttpContext.Current.Application[ROCKGENRES] as List<RockGenres>;
        }
        public static List<SenderType> GetSenderTypes()
        {
            if (HttpContext.Current.Application[SENDERTYPE] == null)
            {
                RockGenresTableAdapter adapter = new RockGenresTableAdapter();
                var typesTable = adapter.GetData();
                List<SenderType> typesList = new List<SenderType>();
                foreach (var row in typesTable)
                {
                    SenderType type = new SenderType();
                    type.ID = Convert.ToInt32(row["ID"]);
                    type.Type = row["Type"].ToString();
                    typesList.Add(type);
                }
                return typesList;
            }
            else
                return HttpContext.Current.Application[SENDERTYPE] as List<SenderType>;
        }
    }
}