﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MusicCommunity.Adapters;
using MusicCommunity.Adapters.UsersDatasetTableAdapters;
using System.Data;
namespace MusicCommunity.Classes
{
    public static class UsersAdapterSpeaker
    {
        public static long GetUserByData(string email, string password)
        {
            Users user = new Users();
            UsersTableAdapter adapter = new UsersTableAdapter();
            long? userId = adapter.CheckUserExist(email, password);
            return userId != null ? (long)userId : -1;
        }
        public static Users GetUserByID(long ID)
        {

            UsersTableAdapter adapter = new UsersTableAdapter();
            var userTable = adapter.GetUserByID(ID);
            if (userTable.Rows.Count != 0)
                return FillUserMainData(userTable.Rows[0]);
            else
                return null;
        }

        private static Users FillUserMainData(DataRow row)
        {
            Users user = new Users();
            user.Email = row["Email"].ToString();
            user.Name = row["Name"].ToString();
            user.Surname = row["Surname"].ToString();
            user.ID = Convert.ToInt64(row["ID"]);
            return user;
        }
        private static List<Users> FillUserMainData(UsersDataset.UsersDataTable table)
        {
            List<Users> users = new List<Users>();
            foreach (var row in table)
            {
                var user = FillUserMainData(row);
                users.Add(user);
            }
            return users;
        }
        public static UserDetails GetUserDetailsByID(long ID)
        {
            UserDetails details = new UserDetails();
            UserDetailsTableAdapter adapter = new UserDetailsTableAdapter();
            var detailsTable = adapter.GetDetailsByID(ID);
            if (detailsTable.Rows.Count != 0)
            {
                var detRow = detailsTable.Rows[0];
                details.UserID = Convert.ToInt64(detRow["UserID"]);
                details.Town = detRow["Town"].ToString();
                details.Skype = detRow["Skype"].ToString();
                details.RegDate = DateTime.Parse(detRow["RegDate"].ToString());
                details.MobPhone = detRow["MobPhone"].ToString();
                details.Country = Convert.ToInt32(detRow["Country"]);
                details.AboutUser = detRow["AboutUser"].ToString();
                return details;
            }
            else
                return null;
        }

    }
}