﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text.RegularExpressions;

using MusicCommunity.Adapters.UsersDatasetTableAdapters;
namespace MusicCommunity.Pages
{
    public partial class HomePage : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            ErrorLiteral.Text = string.Empty;
            if(Request.Cookies.Count != 0)
                if (Request.Cookies["metal"]["UserID"] != null && Request.Cookies["metal"]["UserID"] != string.Empty)
            {
                Session["UserID"] = Request.Cookies["metal"]["UserID"];
                Response.Redirect("User.aspx?id=" + Int32.Parse(Request.Cookies["metal"]["UserID"]));
            }
        }

        protected void loginBtn_Click(object sender, EventArgs e)
        {
            UsersTableAdapter adapter = new UsersTableAdapter();
            long? userId = adapter.CheckUserExist(txtLogin.Text.Replace("'", "''"), txtPassword.Text.Replace("'", "''"));
            if (userId == null)
                ErrorLiteral.Text = "Wrong e-mail or password";
            else
            {
                Session["UserId"] = userId;
                Response.Cookies["metal"]["UserID"] = userId.ToString();
                Response.Redirect("User.aspx?id=" + userId);
            }
        }

        protected void registerBtn_Click(object sender, EventArgs e)
        {
            divWelcome.Visible = false;
            divRegForm.Visible = true;
        }

        protected void regNewBtn_Click(object sender, EventArgs e)
        {
            if (CheckRegFields())
            {
                RegisterUser();
                divRegForm.Visible = false;
                divWelcome.Visible = true;
                ResetTextFields();
            }
        }

        protected void cancelBtn_Click(object sender, EventArgs e)
        {
            divRegForm.Visible = false;
            divWelcome.Visible = true;
        }

        private bool CheckRegFields()
        {
            Regex regEmail = new Regex(@"^(\S+)@([a-z0-9-]+)(\.)([a-z]{2,4})(\.?)([a-z]{0,4})+$");
            Regex regPass = new Regex(@"^(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{8,32}$");
            return regEmail.IsMatch(txtEmail.Text) && regPass.IsMatch(txtPass.Text) && txtPass.Text==txtRepPass.Text
                && CheckString(txtName.Text) && CheckString(txtSurname.Text);
        }

        private bool CheckString(string str)
        {
            return str.Length >= 3;
        }

        private void ResetTextFields()
        {
            txtName.Text = "";
            txtEmail.Text = "";
            txtSurname.Text = "";
            txtPass.Text = "";
        }

        private bool CheckLoginFields()
        {
            return CheckString(txtLogin.Text) && CheckString(txtPassword.Text);
        }

        private void RegisterUser()
        {
            UsersTableAdapter adapter = new UsersTableAdapter();
            adapter.Insert(txtEmail.Text.Replace("'", "''"), txtName.Text.Replace("'", "''"),
                txtPass.Text.Replace("'", "''"), txtSurname.Text.Replace("'", "''"));
        }
    }
}